/*====================================+=====================================+
! File matelefree.h                   ! Copyright (C) 2016-2020 Remi PASCAL !
+-------------------------------------+-------------------------------------+
! This file is part of matelefree.                                          !
! It is free software: you can redistribute it and/or modify it under the   !
! terms of the GNU General Public License as published by the Free Software !
! Foundation, either version 3 of the License, or any later version.        !
! This application is distributed in the hope that it will be useful, but   !
! WITHOUT ANY WARRANTY; without even the implied warranty of                !
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General !
! Public License for more details.                                          !
! You should have received a copy of the GNU General Public License along   !
! with this application. If not, see <http://www.gnu.org/licenses/>.        !
+==========================================================================*/



/*-------------------------------------------------------------------------*/
#pragma once
/*-------------------------------------------------------------------------*/
#include <wx/wx.h>
/*-------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
namespace mtf
{
/*-------------------------------------------------------------------------*/
wxString unspace( wxString s ) ;
wxString unaccent( wxString s ) ;
wxString prepare_string( const wxString &s ) ;
wxString unhtml( const wxString &s ) ;
wxString url_encode( const wxString &s ) ;
int check_ini_entry_name( const wxString &s_name, wxString &s_err_msg ) ;
void draw_wrapped( wxDC &dc, const wxString &s ) ;
/*-------------------------------------------------------------------------*/
#ifdef __WXMSW__
int msw_exe_bitness( const wxString &s_filename ) ;
#endif
/*-------------------------------------------------------------------------*/
wxString read_m3u_line( wxTextInputStream &tis, int &i_line_num ) ;
wxString read_line( wxTextInputStream &tis, int &i_line_num ) ;
int match( const wxString &s_data, const wxString &s_re ... ) ;
int unshort_url( wxString &s_url, wxString *p_s_err_msg ) ;
int wxs2int( const wxString &s ) ;
int rand( int i_min, int i_max ) ;
/*-------------------------------------------------------------------------*/
constexpr int co_i_pl_menu_size   = 100 ;
constexpr int co_i_play_hist_size =  10 ;
/*-------------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/
enum e_id_control
{
   /*----------------------------------------------------------------------*/
   ID_DUMMY_FIRST = wxID_HIGHEST + 1,
   ID_STAY_ON_TOP,
   ID_TOGGLE_MINI_DISPLAY,
   ID_TOGGLE_SHOW,
   ID_TOGGLE_CAPTION,
   ID_DISP_BOPL,
   ID_DISP_PL,
   ID_DISP_CTRL,
   ID_PL_START,
   ID_PL_END = ID_PL_START + mtf::co_i_pl_menu_size,
   ID_PLAY_START_PAUSE,
   ID_PLAY_STOP,
   ID_PLAY_STOP_ALL,
   ID_PLAY_PREV,
   ID_PLAY_NEXT,
   ID_PLAY_HIST,
   ID_PLAY_HIST_MENU,
   ID_PLAY_HIST_START,
   ID_PLAY_HIST_END = ID_PLAY_HIST_START + mtf::co_i_play_hist_size,
   ID_PLAY_HIST_CLEAR,
   ID_FIND_PLAYED_ACTIVE,
   ID_FULLSCREEN,
   ID_SNAPSHOT,
   ID_TOGGLE_MUTE,
   ID_VOLUME_UP,
   ID_VOLUME_DOWN,
   ID_MAKE_DONATION,
   ID_MOVE_UP,
   ID_MOVE_DOWN,
   ID_CHECK_VERSION_MANUAL
   /*----------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/
enum e_pl_known
{  PK_FBTV, PK_FBTVB, PK_FBTVO, PK_FBTVO_OK, PK_FBRADIO, PK_SEARCH,
   PK_LIVE_NODE, PK_LIVE_DM, PK_LIVE_TW, PK_LIVE_YT, PK_LIVE_US,
   PK_LIVE_PE, PK_LIVE_MX,
   PK_USER_NODE, PK_NB
} ;

/*-------------------------------------------------------------------------*/
enum e_download_id { DID_VERSION, DID_NB } ;

/*--------------------------------------------------------------------------+
! Fullscreen has 3 "levels" or types :                                      !
! - no fullscreen                                                           !
! - all media are displayed tiled on the screen                             !
! - only one media is displayed                                             !
+--------------------------------------------------------------------------*/
enum e_fullscreen_level { FSL_NONE, FSL_ALL_MEDIA, FSL_ONE_MEDIA, FSL_NB } ;

/*--------------------------------------------------------------------------+
! This class has been created to answer a problem :                         !
! I want the data to be encoded UTF8 or ISO8859-1 with or without BOM.      !
! Why not using wxConvAuto ?                                                !
! As far as I have tested it, if an UTF8 file BOM is not present, the UTF8  !
! byte sequences are seen as iso8859-1 characters.                          !
! Look at "ToWChar" for more explanation.                                   !
+--------------------------------------------------------------------------*/
class CConv_UTF8_8859_1 : public wxMBConv
{
   /*----------------------------------------------------------------------*/
   public :
      /*-------------------------------------------------------------------*/
      virtual wxMBConv *Clone() const
      {   return new CConv_UTF8_8859_1( *this ) ; }
      virtual size_t ToWChar( wchar_t *dst, size_t dstLen,
                              const char *src, size_t srcLen = wxNO_LEN
                            ) const override ;
      /*-------------------------------------------------------------------*/
} ;

/*-------------------------------------------------------------------------*/



/*==========================================================================+
!                         End of file matelefree.h                          !
+==========================================================================*/
